// AppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "App.h"
#include "AppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAppDlg dialog




CAppDlg::CAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAppDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAppDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()


// CAppDlg message handlers

BOOL CAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	TITLEBARINFO titleBarInfo;
	titleBarInfo.cbSize = sizeof(TITLEBARINFO);
	GetTitleBarInfo(&titleBarInfo);
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(&windowInfo);
	int szerokoscOkno = windowInfo.rcWindow.right - windowInfo.rcWindow.left;
	int wysokoscOkno = windowInfo.rcWindow.bottom - windowInfo.rcWindow.top;
	int wysPaskaTytulu = titleBarInfo.rcTitleBar.bottom;
	int promien=min(wysokoscOkno,szerokoscOkno);
	HRGN rgn=CreateEllipticRgn(0,wysPaskaTytulu,promien,promien);
	SetWindowRgn(rgn,true);

	czyPrzyciskMyszyWcisniety=false;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAppDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	czyPrzyciskMyszyWcisniety=true;
	GetCursorPos(&polozenieMyszyWMomencieWduszeniaPrzycisku);
	this->GetWindowRect(&polozenieOknaWMomencieWduszeniaPrzycisku);

	CDialog::OnLButtonDown(nFlags, point);
}

void CAppDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	czyPrzyciskMyszyWcisniety=false;

	CDialog::OnLButtonUp(nFlags, point);
}

void CAppDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	if(czyPrzyciskMyszyWcisniety)
	{
		POINT biezacePolozenieMyszy;		
		GetCursorPos(&biezacePolozenieMyszy);
		POINT przesuniecieMyszy;
		przesuniecieMyszy.x=biezacePolozenieMyszy.x-polozenieMyszyWMomencieWduszeniaPrzycisku.x;
		przesuniecieMyszy.y=biezacePolozenieMyszy.y-polozenieMyszyWMomencieWduszeniaPrzycisku.y;
		this->SetWindowPos(0,polozenieOknaWMomencieWduszeniaPrzycisku.left+przesuniecieMyszy.x,polozenieOknaWMomencieWduszeniaPrzycisku.top+przesuniecieMyszy.y,0,0,SWP_NOOWNERZORDER | SWP_NOSIZE);
		//this->RedrawWindow();
	}

	CDialog::OnMouseMove(nFlags, point);
}
